#ifndef _GEO_DRAW_DEMO_H_
#define _GEO_DRAW_DEMO_H_

#include "Dx11DemoBase.h"
#include "d3dx11effect.h"
#include "GeometryGenerator.h"

#pragma comment(lib,"d3d11.lib")
#pragma comment(lib,"d3dcompiler.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"dxguid.lib")

class GeoDrawDemo : public Dx11DemoBase
{
public:
	GeoDrawDemo();
	~GeoDrawDemo();

	bool LoadContent() override;
	void UnLoadContent() override;

	void Update(float dt) override;
	void Render() override;

	void OnMouseDown(WPARAM btnState, int x, int y) override;
	void OnMouseUp(WPARAM btnState, int x, int y) override;
	void OnMouseMove(WPARAM btnState, int x, int y) override;
private:
	//
	//ǰͼεĶ㡢һ
	//ͼʱָڻʼλüҵӦĻλ
	ID3D11Buffer*					m_pVertexBuffer;
	ID3D11Buffer*					m_pIndexBuffer;
	ID3D11InputLayout*				m_pInputLayout;

	ID3DX11Effect*					m_pFx;
	ID3DX11EffectTechnique*			m_pTechnique;
	ID3DX11EffectMatrixVariable*	m_pFxWorldViewProj;

	//Ƶļּͼ
	GeometryGenerator::MeshData		m_grid;
	GeometryGenerator::MeshData		m_box;
	GeometryGenerator::MeshData		m_sphere;
	GeometryGenerator::MeshData		m_cylinder;

	//ÿڶʼλ
	UINT							m_gridVStart, m_gridIStart;
	UINT							m_boxVStart, m_boxIStart;
	UINT							m_sphereVStart, m_sphereIStart;
	UINT							m_cylinderVStart, m_cylinderIStart;

	//ͬ任
	XMFLOAT4X4						m_gridWorld;
	XMFLOAT4X4						m_boxWorld;
	//5
	XMFLOAT4X4						m_sphereWorld[5];
	//4Բ
	XMFLOAT4X4						m_cylinderWorld[4];

	//viewproj
	XMFLOAT4X4						m_view;
	XMFLOAT4X4						m_proj;


	float							m_theta;
	float							m_phi;
	float							m_radius;
	POINT							m_lastMousePos;
};

#endif//_GEO_DRAW_DEMO_H_
